import os
import time
import math as math 





def MakeAbqusInput():
    lines = []

    with open("Mal_2_dekker.py") as f1:
        lines = f1.readlines()

    lines.insert(27, "jobname = 'Job-{}'".format(job))
    lines.insert(29, "t11 = {}".format(t11))
    lines.insert(31, "t12 = {}".format(t12))
    lines.insert(33, "t13 = {}".format(t13))

    lines.insert(35, "t2 = {}".format(t2))

    lines.insert(37, "t31 = {}".format(t31))
    lines.insert(39, "t32 = {}".format(t32))
    lines.insert(41, "t33 = {}".format(t33))

    lines.insert(43, "b1 = {}".format(b1))
    lines.insert(45, "b2 = {}".format(b2))
    lines.insert(47, "b3 = {}".format(b3))
    lines.insert(49, "b4 = {}".format(b4))
    lines.insert(51, "t4 = {}".format(t4))

    lines.insert(53, "ovre = '{}'".format(ovre))
    lines.insert(55, "steg = '{}'".format(steg))
    lines.insert(57, "stegK = '{}'".format(stegK))
    lines.insert(59, "ende = '{}'".format(ende))
    lines.insert(61, "nedre = '{}'".format(nedre))
    lines.insert(63, "storB = '{}'".format(storB))

    lines.insert(65, "rho1 = {}".format(rho1))
    lines.insert(67, "rho2 = {}".format(rho2))

    lines.insert(69, "lengde = {}".format(lengde))
    lines.insert(71, "bredde = {}".format(bredde))
    
    lines.insert(73, "flate = 67808.2")                     # 20000 mm^2   969.7*100        Regn om punktlaststorrelse om onskelig
    lines.insert(75, "punktlast = 0.014747")                # 0.05 0.010312  #TILSVARER 1kN



    with open('Til_Abaqus.py', 'w') as f:  # 'w' is a writing mode
        f.truncate(0)
        f.writelines(lines)

def RunAbaqusAnalysis():
    script_name = "Til_Abaqus"
    os.system('abaqus cae noGUI=' + script_name)
    time.sleep(1)

def OutputData(ksi,ovre,steg,stegK,nedre,ende,storB,bredde):
    datContent = [i.strip() for i in open('Job-{}.dat'.format(job)).readlines()]
    output = []
    for i in range(len(datContent)):
        if datContent[i] == 'TOTAL MASS OF MODEL':
            output.append(datContent[i+2])
        if datContent[i] == '(RAD/TIME)   (CYCLES/TIME)':
            output.append((datContent[i+3].split())[3])

    msgContent = [i.strip().split() for i in open('Job-{}.msg'.format(job)).readlines()]
    flatMsgContent = []
    for sublist in msgContent:
        for item in sublist:
            flatMsgContent.append(item)

    for i in range(len(flatMsgContent)):
        if flatMsgContent[i] == 'LARGEST':
            if flatMsgContent[i+1] == 'INCREMENT':
                if flatMsgContent[i+2] == 'OF':
                    if flatMsgContent[i+3] == 'DISP.':
                        output.append(flatMsgContent[i+4])

    intOutput = []

    for i in range(len(datContent)):
        if datContent[i] == 'MOMENTS OF INERTIA ABOUT THE CENTER OF MASS':
            output.append((datContent[i+3].split())[0])
            output.append((datContent[i+3].split())[2])

    for string in output:
        intOutput.append(float(string))

    result = []

    result.append(intOutput[0]*1000)
    result.append(intOutput[1])
    result.append(intOutput[3])
    deflect = intOutput[5]
    result.append(deflect)
    
    result[0] = result[0] - (2*b4*t4/1000000)*(4.8+0.02)*RhoStor #Trekker fra storbjelkene på enden, 0.002 er fordi bjelken stikker 20mm utenfor i modellen

    #Vibrations
    L = lengde/1000
    B = 4.8
    kg = result[0]
    m = kg/L/B 
    M = m*L*B/4
    EI_L = 12500 * intOutput[7] / B         #12500 er antatt total E-modul i lengderetning
    EI_T = 6000 * intOutput[6] / L          #6000 er antatt total E-modul i tverretning

    #Vrms
    f1 = result[1]
    fw = 2
    Im = (42*(fw**1.43))/(f1**1.3)
    k_red = 0.7
    v_1peak = k_red * Im/(M + 70)
    Kimp = max(0.48*(B/L)*(EI_L/EI_T)**0.25,1.0)
    v_totpeak = Kimp * v_1peak
    etta = 1.35 - 0.4*Kimp
    if Kimp < 1.0 or Kimp > 1.7:
        etta = 0.67
    vrms = v_totpeak * ((0.65-0.01*f1)*(1.22-11*ksi)*etta) / 0.0001
    result.append(round(vrms, 3))

    #Arms
    F_h = 500
    my = 0.4
    ksi = 0.04
    k_res = max(0.192*(B/L)*(EI_L/EI_T)**0.25, 1.0 )
    
    a_rms = (k_res*my*F_h)/(math.sqrt(2)*2*ksi*M)
    result.append(round(a_rms, 3))
    result.append(round(m, 3))

    #EPD
    limtre = 53.46 #33-79.3
    clt = 51.68 #34-67
    kbjelke = 91.9
    kerto = 329
    gbjelke = 108.5
    ibjelke = 195.15

    #Volumer
    V_up = (L)*bredde/1000*t1/1000
    V_s = (3*b2/1000)*(L-2*b3/1000)*t2/1000
    V_sk = (2*b1/1000)*L*t2/1000
    V_ned = (L)*bredde/1000*t3/1000 
    V_e = (2*b3/1000)*(bredde-2*b1)/1000*t2/1000
    V_stor = (b4*2/1000)*bredde/1000*t4/1000

    if ovre == 'CLT-C24-1' or ovre == 'CLT-C24-Tung' or ovre == 'CLT-C30' or ovre == 'CLT-C30-Tung':
        plateUpperCO2 =  V_up*clt   
    if ovre == 'Kerto' or ovre == 'Kerto-1' :
        plateUpperCO2 = V_up*kerto    
    if ovre == 'GL28c-1' or ovre == 'GL28c-2' or ovre == 'GL28c-Tung' or ovre == 'GL30c' or ovre == 'GL30c-Tung' or ovre == 'GL30c-2':
        plateUpperCO2 = V_up*limtre

    if steg == 'GL30c' or steg == 'GL28c':
        stegCO2 = V_s*limtre
    if steg == 'K-Bjelke-Plus' or steg == 'K-Bjelke' or steg == 'K-Bjelke-Tung':
        stegCO2 = V_s*kbjelke
    if steg == 'G-Bjelke':
        stegCO2 = V_s*gbjelke
    if steg == 'I-Bjelke':
        stegCO2 = V_s*ibjelke

    if stegK == 'GL30c' or stegK == 'GL28c':
        stegKCO2 = V_sk*limtre
    if stegK == 'K-Bjelke-Plus' or stegK == 'K-Bjelke' or stegK == 'K-Bjelke-Tung':
        stegKCO2 = V_sk*kbjelke
    if stegK == 'G-Bjelke':
        stegKCO2 = V_sk*gbjelke
    if stegK == 'I-Bjelke':
        stegKCO2 = V_sk*ibjelke

    if nedre == 'Kerto' or nedre == 'Kerto-2':
        plateLowerCO2 = V_ned*kerto
    if nedre == 'CLT-C24-2' or nedre == 'CLT-C24-Tung-2' or nedre == 'CLT-C30' or nedre == 'CLT-C30-Tung':
        plateLowerCO2 = V_ned*clt
    if nedre == 'K-Bjelke' or nedre == 'K-Bjelke-Plus' or nedre == 'K-Bjelke-Tung':
        plateLowerCO2 = V_ned*kbjelke
    if nedre == 'GL28c-1' or nedre == 'GL28c-2' or nedre == 'GL28c-Tung' or nedre == 'GL30c' or nedre == 'GL30c-Tung' or nedre == 'GL28h-2' or nedre == 'GL30c-3':
        plateLowerCO2 = V_ned*limtre
    
    if ende == 'GL30c'  or ende == 'GL28c':
        endeCO2 = V_e*limtre
    if ende == 'K-Bjelke-Plus' or ende == 'K-Bjelke':
        endeCO2 = V_e*kbjelke

    CO2Tot = (stegCO2 + stegKCO2 + plateUpperCO2 + plateLowerCO2 + endeCO2)/((L)*bredde/1000)
    result.append(round(CO2Tot, 3))


    #Dersom man tar med bidraget fra storbjelkene mellom soylene
    if storB == 'GL30c'  or storB == 'GL28c':
        storBCO2 = V_stor*limtre
    if storB == 'K-Bjelke-Plus' or storB == 'K-Bjelke' or storB == 'K-Bjelke-Tung':
        storBCO2 = V_stor*kbjelke
    
    CO2Tot2 = CO2Tot + (storBCO2/((L)*bredde/1000))
    result.append(round(CO2Tot2, 3))

    
    #Pris
    Pris_Limtre = 21000                 #Direkte fra Moelven 15 000/25 000,  i Norsk prisbok 21 000
    Pris_CLT = 14500                    #14428, 14260, 14259, 14137, for h = 180, 200, 220, 240 Norsk prisbok

    Pris = (Pris_CLT*(V_up + V_ned) + Pris_Limtre*(V_s + V_sk + V_e))/(lengde/1000)/(bredde/1000)
    result.append(round(Pris, 3))

    Volum = V_up + V_ned + V_s + V_sk + V_e
    result.append(round(Volum, 3))

    roundedList = [ round(elem, 3) for elem in result ]
    
    print(plateUpperCO2, stegCO2, stegKCO2, plateLowerCO2)      #For å kunne se hvilken del bidrar mest til CO2

    return roundedList


def WriteResults():
     with open('Resultater.txt', 'a') as f:
        f.write("Job-{}".format(job))
        f.write('\n')
        f.write("t11 = {}; t12 = {}; t13 = {}; t2 = {};t31 = {}; t32 = {}; t33 = {}; t4 = {}; b1 = {}; b2 = {}; b3 = {}; b4 = {}; ovre = {}; steg = {}; nedre = {}; storB = {}; ksi = {}".format(t11,t12,t13,t2,t31,t32,t33,t4,b1,b2,b3,b4,ovre,steg,nedre,storB,ksi))
        f.write('\n')
        f.write("Total vekt; f1;     HC;   w_max;  Vrms;  Arms; kg/m^2; kgCo2/m^2; kgCo2/m^2(2); kr/m^2; m^3")
        f.write('\n')
        for line in OUT:
            f.write(str(line)+"; ")
        f.write('\n')
        f.write('\n')

def DeleteFiles():
    os.remove("abaqus.rpy")
    os.remove("Job-{}.com".format(job))
    os.remove("Job-{}.inp".format(job))
    os.remove("Job-{}.log".format(job))
    os.remove("Job-{}.odb".format(job))
    os.remove("Job-{}.prt".format(job))
    os.remove("Job-{}.sim".format(job))
    os.remove("Job-{}.sta".format(job))
    os.remove("Job-{}.dat".format(job))
    os.remove("Job-{}.msg".format(job))



#Her velges variablene som onskes aa testes. Maa minst staa en i hver for at koden skal funke. Trenger ikke bruke de
variable1 = [25]      
variable2 = [10]
 

startjobnum = 1                             #Hvilket jobbnumer som skal dukke opp i resultater. Gaar automatisk opp om det er flere jobber

for j in range(len(variable2)):      
    for i in range(len(variable1)):
        job = startjobnum
        var1 = variable1[i]
        var2 = variable2[j]

        lengde = 10000
        bredde = 2400

        ksi = 0.04                          #0.04 i 9.3.1 i forslag til ny Eurokode 5

        t11 = var1                          #Tykkelse øvre lag i øvre CLT
        t12 = var2                          #Tykkelse midtre lag i øvre CLT             #Dette laget har vinkel 90 grader
        t13 = 25                            #Tykkelse nedre lag i øvre CLT
        t1 = t11+t12+t13                    #Tykkelse øvre flens
        
        t2 = 360                            #Hoyde steg
        
        t31 = 25                            #Tykkelse øvre lag i nedre CLT
        t32 = 10                            #Tykkelse nedre lag i nedre CLT             #Dette laget har vinkel 90 grader
        t33 = 25
        t3 = t31+t32+t33                    #Tykkelse nedre flens

        b1 = 115                            #Bredde kantsteg
        b2 = 45                            #Bredde midtre steg
        b3 = 115                            #Bredde endebjelke
        b4 = 200                            #bredde Storbjelke
        t4 = 800                            #Hoyde storbjelke


        #Modell 1                           #Tilgjengelig materialer ser man i Mal_2_dekker.py
        ovre = 'CLT-C24-1'
        steg = 'GL28c'
        stegK = 'GL30c'              
        ende = 'GL30c'
        nedre = 'CLT-C24-2'
        storB = 'GL30c'
        RhoStor = 430                       #Tyngdetetthet for storbjelken som trekkes fra total masse for vibrasjonsberegninger (430 for GL30c)

        #Justering av tyngdetettheten til flensene for aa ta i betraktning gulv- og himlingsoppbygningen i beregninger
        rho1 = 4.2 + 42.7/(t1/1000)/100     #42,7 er antall kilo gulvoppbygningen veier
        rho2 = 4.2 + 22.9/(t3/1000)/100     #22,9 er himlingen


        #Selvforklarende nedenfor. Kommenter ut med # det man eventuelt ikke vil skal skje
        MakeAbqusInput()
        RunAbaqusAnalysis()

        OUT = OutputData(ksi,ovre,steg,stegK,nedre,ende,storB,bredde)

        print(OUT)
        WriteResults()
        DeleteFiles()
        
        startjobnum += 1